{
    inputs = {
        flake-utils.url = "github:numtide/flake-utils";
        oxalica.url     = "github:oxalica/rust-overlay";
        naersk.url      = "github:nix-community/naersk";
    };

    outputs = { self, nixpkgs, flake-utils, naersk, oxalica }:
    	flake-utils.lib.eachDefaultSystem (system:
            let pkgs = import nixpkgs { inherit system; overlays = [ oxalica.overlay ]; };
                naersk-lib = naersk.lib."${system}";
            in rec {
                # `nix build`
                packages."hermit" = naersk-lib.buildPackage {
                    pname = "hermit";
                    root = ./.;
                };
                
                defaultPackage = packages."hermit";

                # `nix run`
                apps."hermit"= flake-utils.lib.mkApp {
                    drv = packages."hermit";
                };

                defaultApp = apps."hermit";

                # `nix develop`
                devShell = pkgs.mkShell {
                    nativeBuildInputs = with pkgs; [
                        (rust-bin.selectLatestNightlyWith (t: t.default))
                        openssl
                        pkgconfig
                    ];
                };
            }
        );
}
